package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.classfile.ConstantCP;
import com.sun.org.apache.bcel.internal.classfile.Constant;
import com.sun.org.apache.bcel.internal.Const;
import java.util.StringTokenizer;
import com.sun.org.apache.bcel.internal.classfile.ConstantPool;

public abstract class InvokeInstruction extends FieldOrMethod implements ExceptionThrower, StackConsumer, StackProducer
{
    InvokeInstruction() {
    }
    
    protected InvokeInstruction(short opcode, int index) {
        super(opcode, index);
    }
    
    @Override
    public String toString(ConstantPool cp) {
        Constant c = cp.getConstant(super.getIndex());
        StringTokenizer tok = new StringTokenizer(cp.constantToString(c));
        return Const.getOpcodeName((int)super.getOpcode()) + " " + tok.nextToken().replace('.', '/') + tok.nextToken();
    }
    
    @Override
    public int consumeStack(ConstantPoolGen cpg) {
        int sum;
        if (super.getOpcode() == 184 || super.getOpcode() == 186) {
            sum = 0;
        }
        else {
            sum = 1;
        }
        String signature = this.getSignature(cpg);
        sum += Type.getArgumentTypesSize(signature);
        return sum;
    }
    
    @Override
    public int produceStack(ConstantPoolGen cpg) {
        String signature = this.getSignature(cpg);
        return Type.getReturnTypeSize(signature);
    }
    
    @Deprecated
    @Override
    public String getClassName(ConstantPoolGen cpg) {
        ConstantPool cp = cpg.getConstantPool();
        ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
        String className = cp.getConstantString(cmr.getClassIndex(), (byte)7);
        return className.replace('/', '.');
    }
    
    @Override
    public Type getType(ConstantPoolGen cpg) {
        return this.getReturnType(cpg);
    }
    
    public String getMethodName(ConstantPoolGen cpg) {
        return this.getName(cpg);
    }
    
    public Type getReturnType(ConstantPoolGen cpg) {
        return Type.getReturnType(this.getSignature(cpg));
    }
    
    public Type[] getArgumentTypes(ConstantPoolGen cpg) {
        return Type.getArgumentTypes(this.getSignature(cpg));
    }
}
